#!/bin/bash
# escaped.sh: ת

echo; echo

echo "\v\v\v\v"      # ֵĴӡ\v\v\v\v.
# ʹ-eѡ'echo'ӡת.
echo "============="
echo "VERTICAL TABS"
echo -e "\v\v\v\v"   # ӡ4ֱƱ.
echo "=============="

echo "QUOTATION MARK"
echo -e "\042"       # ӡ" (, 8ƵASCII 42).
echo "=============="

# ʹ$'\X'ṹ,-eѡͲҪ.
echo; echo "NEWLINE AND BEEP"
echo $'\n'           # .
echo $'\a'           # ().

echo "==============="
echo "QUOTATION MARKS"
# 汾2ԺBashʹ$'\nnn'ṹ.
# ע, '\nnn\'8Ƶֵ.
echo $'\t \042 \t'   # ˮƽƱ(").

# Ȼ,Ҳʹ16Ƶֵ,ʹ$'\xhhh' ṹ.
echo $'\t \x22 \t'  # ˮƽƱ(").
# л, Greg Keraunen, ָ.
# һBash汾'\x022'ʽ.
echo "==============="
echo


# ASCIIַ.
# ----------------------------------------
quote=$'\042'        # " ֵ.
echo "$quote This is a quoted string, $quote and this lies outside the quotes."

echo

# еASCIIַ.
triple_underline=$'\137\137\137'  # 137ǰ˽Ƶ'_'.
echo "$triple_underline UNDERLINE $triple_underline"

echo

ABC=$'\101\102\103\010'           # 101, 102, 103ǰ˽A, B, C.
echo $ABC

echo; echo

escape=$'\033'                    # 033 ǰ˽esc.
echo "\"escape\" echoes as $escape"
#                                   ûб.

echo; echo

exit 0
