#!/bin/bash

echo
echo "String operations using \"expr \$string : \" construct"
echo "==================================================="
echo

a=1234zipper5FLIPPER43231

echo "The string being operated upon is \"`expr "$a" : '\(.*\)'`\"."
#     תŶԵĲ.						            ==  ==

#       ***************************
#+				תŶ
#+           ƥһӴ
#       ***************************


#  תŵĻ...
#+ ô'expr'stringתΪһ.

echo "Length of \"$a\" is `expr "$a" : '.*'`."   # ַ

echo "Number of digits at the beginning of \"$a\" is `expr "$a" : '[0-9]*'`."

# ------------------------------------------------------------------------- #

echo

echo "The digits at the beginning of \"$a\" are `expr "$a" : '\([0-9]*\)'`."
#                                                             ==      ==
echo "The first 7 characters of \"$a\" are `expr "$a" : '\(.......\)'`."
#         =====                                          ==       ==
# һ, תŶǿһӴƥ.
#
echo "The last 7 characters of \"$a\" are `expr "$a" : '.*\(.......\)'`."
#         ====                  ַĽβ		^^
#  (ģʽ˼Ǻǰߵκַ,ֱ7ַ,
#+  7Ҫƥ7ִַ)

echo

exit 0
