#!/bin/bash
# file-integrity.sh: һĿ¼µļ
#                    Ƿ񱻸Ķ. 

E_DIR_NOMATCH=70
E_BAD_DBFILE=71

dbfile=File_record.md5
# 洢¼ļ(ݿļ).


set_up_database ()
{
  echo ""$directory"" > "$dbfile"
  # Ŀ¼дļĵһ. 
  md5sum "$directory"/* >> "$dbfile"
  # ļиmd5 checksumfilename. 
}

check_database ()
{
  local n=0
  local filename
  local checksum

  # ------------------------------------------- #
  #  ļʵǲҪ,
  #+ ܸȫһЩ.

  if [ ! -r "$dbfile" ]
  then
    echo "Unable to read checksum database file!"
    exit $E_BAD_DBFILE
  fi
  # ------------------------------------------- #

  while read record[n]
  do

    directory_checked="${record[0]}"
    if [ "$directory_checked" != "$directory" ]
    then
      echo "Directories do not match up!"
      # Ŀ¼һ. 
      exit $E_DIR_NOMATCH
    fi

    if [ "$n" -gt 0 ]   # Ŀ¼. 
    then
      filename[n]=$( echo ${record[$n]} | awk '{ print $2 }' )
      #  md5sumд¼, 
      #+ дchecksum, Ȼдfilename. 
      checksum[n]=$( md5sum "${filename[n]}" )


      if [ "${record[n]}" = "${checksum[n]}" ]
      then
        echo "${filename[n]} unchanged."

      elif [ "`basename ${filename[n]}`" != "$dbfile" ]
             #  checksumݿļ, 
             #+ Ϊÿεýűᱻ޸. 
	     #  ---
	     #  ⲻҵζŵ$PWDűʱ, 
	     #+ ۸checksum
	     #+ ݿļᱻ. 
	     #  ϰ: .
	then
          echo "${filename[n]} : CHECKSUM ERROR!"
        # ϴεļ֮, ļѾ޸. 
      fi

      fi



    let "n+=1"
  done <"$dbfile"       # checksumݿļж.  

}  

# =================================================== #
# main ()

if [ -z  "$1" ]
then
  directory="$PWD"      #  ûָĻ, 
else                    #+ ôʹõǰĹĿ¼. 
  directory="$1"
fi  

clear                   # .
echo " Running file integrity check on $directory"
echo

# ------------------------------------------------------------------ #
  if [ ! -r "$dbfile" ] # ǷҪݿļ? 
  then
    echo "Setting up database file, \""$directory"/"$dbfile"\"."; echo
    set_up_database
  fi  
# ------------------------------------------------------------------ #

check_database          # Ҫ. 

echo 

#  űضļ, 
#+ Ŀ¼кܶļʱ. 

exit 0

#  ҪǳļԼ, 
#+ Կһ"Tripwire",
#+ http://sourceforge.net/projects/tripwire/.

