#!/bin/bash
# wstrings.sh: "word-strings" (ǿ"strings")
#
#  űͨų׼бʽ
#+ "strings". 
#  ⽫ЧĹ˵ַ, 
#+ ֻʶַ. 

# ===========================================================
#                 űı׼
ARGS=1
E_BADARGS=65
E_NOFILE=66

if [ $# -ne $ARGS ]
then
  echo "Usage: `basename $0` filename"
  exit $E_BADARGS
fi

if [ ! -f "$1" ]                      # ļǷ. 
then
    echo "File \"$1\" does not exist."
    exit $E_NOFILE
fi
# ===========================================================


MINSTRLEN=3                           #  Сַ.
WORDFILE=/usr/share/dict/linux.words  #  ֵļ.
                                      #  Ҳָһͬ
                                      #+ бļ,
                                      #+ ļÿһеķʽб.


wlist=`strings "$1" | tr A-Z a-z | tr '[:space:]' Z | \
tr -cs '[:alpha:]' Z | tr -s '\173-\377' Z | tr Z ' '`

#  'strings'ͨܵݵ'tr'.
#  "tr A-Z a-z" ȫתΪСдַ.
#  "tr '[:space:]'" תհַΪZ.
#  "tr -cs '[:alpha:]' Z" ĸַתΪZ,
#+ ȻȥZ.
#  "tr -s '\173-\377' Z" zߵַתΪZ.
#+ ȥظZ. (ע173(123 ascii "{")377(255 ascii һַ)8)
#+ ֮, ֮ǰҪͷʹַ
#+ ȫתΪַZ.
#  "tr Z ' '" еZתΪո,
#+ ±ѭõıwlistеݾȫԿոָ.

#  ****************************************************************
#  ע, ʹùܵ'tr'ݵһ'tr'ʱ 
#+ ÿζʹ˲ͬĲ. 
#  ****************************************************************


for word in $wlist                    # Ҫ:
                                      # $wlist ﲻʹ˫.
                                      # "$wlist" .
                                      # Ϊʲô?
do                                                                 
                                                                   
  strlen=${#word}                     # ַ.
  if [ "$strlen" -lt "$MINSTRLEN" ]   # ̵ַ.
  then                                                             
    continue                                                       
  fi                                                               
                                                                   
  grep -Fw $word "$WORDFILE"          #  ֻƥ.
#      ^^^                            #  "̶ַ" 
                                      #+ "" ѡ. 

done  


exit $?
