#!/bin/bash
# Du.sh: DOSUNIXıļת.

E_WRONGARGS=65

if [ -z "$1" ]
then
  echo "Usage: `basename $0` filename-to-convert"
  exit $E_WRONGARGS
fi

NEWFILENAME=$1.unx

CR='\015'  # س.
           # 0158ƵASCIIĻس.
           # DOSıļнCR-LF.
           # UNIXıļнֻLF.

tr -d $CR &lt; $1 &gt; $NEWFILENAME
# ɾسдļ. 

echo "Original DOS text file is \"$1\"."
echo "Converted UNIX text file is \"$NEWFILENAME\"."

exit 0

# ϰ:
# -----
# ޸ϱߵĽűɴUNIXDOSת. 
