#!/bin/bash
# arglist.sh
# ʹüű, "one two three".

E_BADARGS=65

if [ ! -n "$1" ]
then
  echo "Usage: `basename $0` argument1 argument2 etc."
  exit $E_BADARGS
fi  

echo

index=1          # ʼ.

echo "Listing args with \"\$*\":"
for arg in "$*"  # "$*""",ôع.
do
  echo "Arg #$index = $arg"
  let "index+=1"
done             # $* еĲһ.
echo "Entire arg list seen as single word."

echo

index=1          # ü(ע: 1ʼ).
                 # дᷢʲô?

echo "Listing args with \"\$@\":"
for arg in "$@"
do
  echo "Arg #$index = $arg"
  let "index+=1"
done             # $@ ÿǵĵ.
echo "Arg list seen as separate words."

echo

index=1          # ü(ע: 1ʼ).

echo "Listing args with \$* (unquoted):"
for arg in $*
do
  echo "Arg #$index = $arg"
  let "index+=1"
done             # δõ$*Ѳɵĵ. 
echo "Arg list seen as separate words."

exit 0
