#!/bin/bash
# cannon.sh: Approximating PI by firing cannonballs.

# ʵһ"Monte Carlo"ؿģķǳ򵥵ʵ:
#+ ؿģһʵ¼ѧģ,
#+ Ҫʹͳѧ, ʹαģ.

#  һ, ߳Ϊ10000λ.
#  صмһԲκ,
#+ ֱ10000λ.
#  صľˮ, Ȼֻ4һЩ.
#  (԰ΪεڽԲ.)
#
#  ǽʹʽĴںڵ
#+ εϿ.
#  еڵصĳط.
#+ Ǵ򵽺, Ǵ4ǵ.
#  Ϊռ󲿷ֵط,
#+ Դ󲿷ֵڵ"ͨ"һ䵽ˮ.
#  ֻкٵڵ""һ䵽4
#+ ǵ.
#
#  Ƿڵ㹻䵽еĻ,
#+ ô䵽ˮڵڵı,
#+ ŷǳӽPI/4.
#
#  ԭеڵʵ϶
#+ صϽ,
#+ Ҳ, ѿϵĵһ.
#  (֮ǰĽֻһ.)
#
#  ˵, ڵԽ, Խӽ.
#  Ȼ, shell ű˵һЩò,
#+ Ϊ϶ܺЩڽָ֧ı.
#  Ȼͻή;.


DIMENSION=10000  # صı߳.
                 # Ҳ.
                                                                         
MAXSHOTS=1000    # ڴ.
                 # 10000εĻ, ЧӦø, е̫˷ʱ.
PMULTIPLIER=4.0  # ӽPIı.

get_random ()
{
SEED=$(head -1 /dev/urandom | od -N 1 | awk '{ print $2 }')
RANDOM=$SEED                                  #  "seeding-random.sh"
                                              #+ ӽű.
let "rnum = $RANDOM % $DIMENSION"             #  ΧС10000.
echo $rnum
}

distance=        # ȫֱ.
hypotenuse ()    # "alt-bc.sh",
{                # ֱεбߵĺ.
distance=$(bc -l << EOF
scale = 0
sqrt ( $1 * $1 + $2 * $2 )
EOF
)
#   "scale" Ϊ 0 , ýΪֵ,
#+ Ҳűбеһط.
#  ҵ, ⽫ģľ.
}


# main() {

# ʼ. 
shots=0
splashes=0
thuds=0
Pi=0

while [ "$shots" -lt  "$MAXSHOTS" ]           # ѭ.
do                                                                      
                                                                        
  xCoord=$(get_random)                        # ȡ X  Y .
  yCoord=$(get_random)                                                  
  hypotenuse $xCoord $yCoord                  #  ֱб =
                                              #+ distance.
  ((shots++))                                                           
                                                                        
  printf "#%4d   " $shots                                               
  printf "Xc = %4d  " $xCoord                                           
  printf "Yc = %4d  " $yCoord                                           
  printf "Distance = %5d  " $distance         #  ĵ
                                              #+  --
                                              #  ʼ --
                                              #+  (0,0).

  if [ "$distance" -le "$DIMENSION" ]
  then
    echo -n "SPLASH!  "
    ((splashes++))
  else
    echo -n "THUD!    "
    ((thuds++))
  fi

  Pi=$(echo "scale=9; $PMULTIPLIER*$splashes/$shots" | bc)
  # 4.0.
  echo -n "PI ~ $Pi"
  echo

done

echo
echo "After $shots shots, PI looks like approximately $Pi."
# ̫׼Ļ, ôһеĴ. . .
# д̶Ȳɵ.
echo

# }

exit 0

#  Ҫ֪һshellűʲʺ϶ԼӦýģĻ?
#+ (һҪԸӶȺ;ȶҪļӦ).
#
#  һҪж.
#  1) Ϊһָ֤: ʾ. 
#  2) ʹıʵһ㷨֮ǰ, 
#+    ʹýűԺ֤㷨. 
