#!/bin/bash
# letter-count.sh: ͳһıļĳЩĸֵĴ.
# Stefano Palmeriд. 
# Ȩʹڱ. 
# ޸. 

MINARGS=2          # űҪ2. 
E_BADARGS=65
FILE=$1

let LETTERS=$#-1   # ָ˶ٸĸ(Ϊв).
                   # (вĸм1.)


show_help(){
	   echo
           echo Usage: `basename $0` file letters  
           echo Note: `basename $0` arguments are case sensitive.
           echo Example: `basename $0` foobar.txt G n U L i N U x.
	   echo
}

# . 
if [ $# -lt $MINARGS ]; then
   echo
   echo "Not enough arguments."
   echo
   show_help
   exit $E_BADARGS
fi  


# ļǷ. 
if [ ! -f $FILE ]; then
    echo "File \"$FILE\" does not exist."
    exit $E_BADARGS
fi



# ͳĸֵĴ. 
for n in `seq $LETTERS`; do
      shift
      if [[ `echo -n "$1" | wc -c` -eq 1 ]]; then             #  .
             echo "$1" -\> `cat $FILE | tr -cd  "$1" | wc -c` #  ͳ. 
      else
             echo "$1 is not a  single char."
      fi  
done

exit $?

#  űڹletter-count2.shȫͬ, 
#+ еø. 
#  Ϊʲô? 
