#!/bin/bash
# pid-identifier.sh: ָpid̵·. 

ARGNO=1  # Ĳ. 
E_WRONGARGS=65
E_BADPID=66
E_NOSUCHPROCESS=67
E_NOPERMISSION=68
PROCFILE=exe

if [ $# -ne $ARGNO ]
then
  echo "Usage: `basename $0` PID-number" >&2  # Error message >stderr(Ϣض򵽱׼). 
  exit $E_WRONGARGS
fi  

pidno=$( ps ax | grep $1 | awk '{ print $1 }' | grep $1 )
# "ps"pid, pidλڵһ#1, awk˳. 
# ȻٴȷҪҵĽ, űĽ. 
# "grep $1"˵ֿ. 
#
#    pidno=$( ps ax | awk '{ print $1 }' | grep $1 )
#    ôдͿ, һTeemu Huovilaָ. 

if [ -z "$pidno" ]  # еĹ֮, õĽһΪ0ַ, 
then                # Ǿ˵pidûӦĽ. 
  echo "No such process running."
  exit $E_NOSUCHPROCESS
fi  

# Ҳôд: 
#   if ! ps $1 > /dev/null 2>&1
#   then                # ûpidƥĽ. 
#     echo "No such process running."
#     exit $E_NOSUCHPROCESS
#    fi

# Ϊ˼, ʹ"pidof". 


if [ ! -r "/proc/$1/$PROCFILE" ]  # Ȩ. 
then
  echo "Process $1 running, but..."
  echo "Can't get read permission on /proc/$1/$PROCFILE."
  exit $E_NOPERMISSION  # һûܷ/procĿ¼µĳЩļ. 
fi  

# Կʹ: 
#    if ! kill -0 $1 > /dev/null 2>&1 # '0'һź, but
                                      # ô, ԲһǷ
                                      # ý̷ź. 
#    then echo "PID doesn't exist or you're not its owner" >&2
#    exit $E_BADPID
#    fi



exe_file=$( ls -l /proc/$1 | grep "exe" | awk '{ print $11 }' )
#        exe_file=$( ls -l /proc/$1/exe | awk '{print $11}' )
#
# /proc/pid-number/exeһ, 
# ָý̵·. 

if [ -e "$exe_file" ]  # /proc/pid-number/exe...
then                 # ôӦĽ̾ʹ. 
  echo "Process #$1 invoked by $exe_file."
else
  echo "No such process running."
fi  


# Ľű, **ܹ±һ: 
# ps ax | grep $1 | awk '{ print $5 }'
# , Ṥ...
# Ϊ'ps'ĵ5ǽ̵argv[0](ע: еһ, ʱõĳ·.)
# ǿִļ·. 
#
# Ȼ, ±ַȷ. 
#       find /proc/$1/exe -printf '%l\n'
#       lsof -aFn -p $1 -d txt | sed -ne 's/^n//p'

# ע, Stephane Chazelasӵ. 

exit 0
