#!/bin/bash
# random-between.sh
# ֵָ֮.
# Bill Gradwohlд, һЩ޸.
# űʹ.


randomBetween() {
   #  $min$max֮,
   #+ һĻ򸺵.
   #+ ҿԱ$divisibleBy.
   #  һķֵ.
   #
   #  Bill Gradwohl - Oct 1, 2003

   syntax() {
   # ںǶ
      echo
      echo    "Syntax: randomBetween [min] [max] [multiple]"
      echo
      echo    "Expects up to 3 passed parameters, but all are completely optional."
      echo    "min is the minimum value"
      echo    "max is the maximum value"
      echo    "multiple specifies that the answer must be a multiple of this value."
      echo    "    i.e. answer must be evenly divisible by this number."
      echo    
      echo    "If any value is missing, defaults area supplied as: 0 32767 1"
      echo    "Successful completion returns 0, unsuccessful completion returns"
      echo    "function syntax and 1."
      echo    "The answer is returned in the global variable randomBetweenAnswer"
      echo    "Negative values for any passed parameter are handled correctly."
   }

   local min=${1:-0}
   local max=${2:-32767}
   local divisibleBy=${3:-1}
   # Ĭֵ, ûвݽ.

   local x
   local spread

   # ȷdivisibleByֵ.
   [ ${divisibleBy} -lt 0 ] && divisibleBy=$((0-divisibleBy))

   # Լ.
   if [ $# -gt 3 -o ${divisibleBy} -eq 0 -o  ${min} -eq ${max} ]; then 
      syntax
      return 1
   fi

   # 鿴minmaxǷߵ.
   if [ ${min} -gt ${max} ]; then
      # .
      x=${min}
      min=${max}
      max=${x}
   fi

   #  minԼܹ$divisibleBy,
   #+ ô͵maxֵ, ʹܹ$divisibleBy, ǰǲܷŴΧ.
   if [ $((min/divisibleBy*divisibleBy)) -ne ${min} ]; then 
      if [ ${min} -lt 0 ]; then
         min=$((min/divisibleBy*divisibleBy))
      else
         min=$((((min/divisibleBy)+1)*divisibleBy))
      fi
   fi

   #  minԼܹ$divisibleBy,
   #+ ô͵maxֵ, ʹܹ$divisibleBy, ǰǲܷŴΧ.
   if [ $((max/divisibleBy*divisibleBy)) -ne ${max} ]; then 
      if [ ${max} -lt 0 ]; then
         max=$((((max/divisibleBy)-1)*divisibleBy))
      else
         max=$((max/divisibleBy*divisibleBy))
      fi
   fi

   #  ---------------------------------------------------------------------
   #  , Ĺ.

   #  ע, Ϊ˵õڶ˵˵ʵķ,
   #+ ֵķΧò
   #+ 0  abs(max-min)+divisibleBy ֮,  abs(max-min)+1.

   #  ڶ˵˵,
   #+ ӽʵķ.

   #  ޸ʽ, ʹ abs(max-min)+1  abs(max-min)+divisibleByĻ, 
   #+ ҲܹõȷĴ, ɵֵΪ˵㱶
   #+ ˵ǲ, ΪΪ˵㱶µʱȽϵ,
   #+ Ϊż1, ĹʽļҪСĶ(ΪdivisibleBy).
   #  ---------------------------------------------------------------------

   spread=$((max-min))
   [ ${spread} -lt 0 ] && spread=$((0-spread))
   let spread+=divisibleBy
   randomBetweenAnswer=$(((RANDOM%spread)/divisibleBy*divisibleBy+min))   

   return 0

   #  Ȼ, Paulo Marcel Coelho Aragao ָ
   #+  $max  $min ܹ$divisibleByʱ,
   #+ ʽʧ.
   #
   #  ʹ¹ʽ:
   #    rnumber = $(((RANDOM%(max-min+1)+min)/divisibleBy*divisibleBy))

}

# ǲһ.
min=-14
max=20
divisibleBy=3


#  һanswers, ±ʾڷΧڿֵֵܳ,
#+ Ԫݼ¼ֵֵĴ, ѭ㹻, ôһõһγֻ.

declare -a answer
minimum=${min}
maximum=${max}
   if [ $((minimum/divisibleBy*divisibleBy)) -ne ${minimum} ]; then 
      if [ ${minimum} -lt 0 ]; then
         minimum=$((minimum/divisibleBy*divisibleBy))
      else
         minimum=$((((minimum/divisibleBy)+1)*divisibleBy))
      fi
   fi


132    #  maxܹ$divisibleBy,
133    #+ ô͵maxֵ, ʹܹ$divisibleBy, ǰǲܷŴΧ.

   if [ $((maximum/divisibleBy*divisibleBy)) -ne ${maximum} ]; then 
      if [ ${maximum} -lt 0 ]; then
         maximum=$((((maximum/divisibleBy)-1)*divisibleBy))
      else
         maximum=$((maximum/divisibleBy*divisibleBy))
      fi
   fi


#  Ҫһ±ȫΪ.
#+ Ҫһdisplacement, 
#+ ͿԱ֤Ϊ. 

displacement=$((0-minimum))
for ((i=${minimum}; i<=${maximum}; i+=divisibleBy)); do
   answer[i+displacement]=0
done


# , ѭ㹻Ĵ, õҪĴ.
loopIt=1000   #  ű߽ѭ 100000 ,
              #+ Ҫʱ̫.

for ((i=0; i<${loopIt}; ++i)); do

   #  ע, randomBetweenAnswerʱ, ƽminmaxߵ˳.
   #+ Ϊ˲, ˺Ƿȷ.

   randomBetween ${max} ${min} ${divisibleBy}

   # 𰸲, ͱ.
   [ ${randomBetweenAnswer} -lt ${min} -o ${randomBetweenAnswer} -gt ${max} ] && echo MIN or MAX error - ${randomBetweenAnswer}!
   [ $((randomBetweenAnswer%${divisibleBy})) -ne 0 ] && echo DIVISIBLE BY error - ${randomBetweenAnswer}!

   # ͳֵ浽answer.
   answer[randomBetweenAnswer+displacement]=$((answer[randomBetweenAnswer+displacement]+1))
done



# 쿴һ½.

for ((i=${minimum}; i<=${maximum}; i+=divisibleBy)); do
   [ ${answer[i+displacement]} -eq 0 ] && echo "We never got an answer of $i." || echo "${i} occurred ${answer[i+displacement]} times."
done


exit 0
